public class CCurve
{
  // properties
  protected int m_nYear_s;
  protected int m_nYearDay_s;
  protected int m_nYear_e;
  protected int m_nYearDay_e;
  protected int m_ndeweyclass;

  protected float m_fLongitude_s; // theta
  protected float m_fLatitude_s;  // pi
  protected float m_fLongitude_e; // theta
  protected float m_fLatitude_e;  // pi

  protected float m_fX_s, m_fY_s, m_fZ_s;
  protected float m_fX_e, m_fY_e, m_fZ_e;
  protected float m_fColor;

  // constructor
  CCurve(int nYear_s, int nMonth_s, int nDay_s, int nYearDay_s, int nYear_e, int nMonth_e, int nDay_e, int nYearDay_e, int nDeweyClass, float fScale)
  {
    m_nYear_s = nYear_s;
    m_nYearDay_s = nYearDay_s;
    m_nYear_e = nYear_e;
    m_nYearDay_e = nYearDay_e;
    m_ndeweyclass = nDeweyClass;

    m_fLongitude_s = map((nYear_s-2005) * 365 + nYearDay_s, 1-365, (2011-2005+1)*365+365, PI, 0);
    m_fLatitude_s  = map(nYearDay_s, 1, 366, TWO_PI, 0);
    m_fLongitude_e = map((nYear_e-2005) * 365 + nYearDay_e, 1-365, (2011-2005+1)*365+365, PI, 0);
    m_fLatitude_e  = map(nYearDay_e, 1, 366, TWO_PI, 0);

    m_fColor     = map(nDeweyClass, 0, 999, 0f, 1f);
    
    m_fX_s = fScale * sin(m_fLongitude_s) * cos(m_fLatitude_s);
    m_fZ_s = fScale * sin(m_fLongitude_s) * sin(m_fLatitude_s);
    m_fY_s = fScale * cos(m_fLongitude_s);

    m_fX_e = fScale * sin(m_fLongitude_e) * cos(m_fLatitude_e);
    m_fZ_e = fScale * sin(m_fLongitude_e) * sin(m_fLatitude_e);
    m_fY_e = fScale * cos(m_fLongitude_e);
  }
  
  // draw
  void draw()
  {
    pushStyle();
    colorMode(RGB, 255, 255, 255, 100);
   // stroke(m_fColor, 1f, 1f, .3f);
    strokeWeight(1f);
    
    if ((m_ndeweyclass < 200) && (m_ndeweyclass > 0) ) { stroke(255,0,0,100); } // RED
    else if ((m_ndeweyclass < 300) && (m_ndeweyclass > 200)) { emissive(205,71,55); stroke(205,71,55, 100); } // RED2
    else if ((m_ndeweyclass < 350) && (m_ndeweyclass > 300)) { emissive(211,57,138); stroke(211,57,138, 100); } // PINK
    else if ((m_ndeweyclass < 400) && (m_ndeweyclass > 350)) { emissive(255,134,0); stroke(255,134,0, 100); } // ORANGE
    else if ((m_ndeweyclass < 400) && (m_ndeweyclass > 350)) { emissive(255,221,0); stroke(255,221,0, 100); } // YELLOW
    else if ((m_ndeweyclass < 450) && (m_ndeweyclass > 400)) { emissive(0,253,181); stroke(0,253,181, 100); } // YELLOW GREEN
    else if ((m_ndeweyclass < 500) && (m_ndeweyclass > 450)) { emissive(20,167,124); stroke(20,167,124, 100); } // GREEN
    else if ((m_ndeweyclass < 600) && (m_ndeweyclass > 500)) { emissive(50,131,75); stroke(50,131,75, 100); } // GREEN
    else if ((m_ndeweyclass < 700) && (m_ndeweyclass > 600)) { emissive(0,189,255); stroke(0,189,255, 100); } // SKY BLUE
    else if ((m_ndeweyclass < 800) && (m_ndeweyclass > 700)) { emissive(0,126,255); stroke(0,126,255, 50); } // BLUE
    else if ((m_ndeweyclass < 900) && (m_ndeweyclass > 800)) { emissive(144,0,255); stroke(144,0,255, 50); } // VIOLET
    else if ((m_ndeweyclass < 1000) && (m_ndeweyclass > 900)) { emissive(143,17,140); stroke(143,17,140, 50); } // PINK2
    else fill(255,255,255);
    
    line(m_fX_s, m_fY_s, m_fZ_s, m_fX_e, m_fY_e, m_fZ_e);
    popStyle();
  }
}
