public class CRecord
{
  protected int m_nYear;
  protected int m_nMonth;
  protected int m_nDay;
  protected int m_nYearDay;
  protected int m_nDuration;
  protected int m_ndeweyclass;
  protected String m_strTitle;
  protected String m_strDate;
  
  protected float m_fRadius = 0f;    // R
  protected float m_fLongitude = 0f; // theta
  protected float m_fLatitude = 0f;  // pi
  
  protected float m_fX, m_fY, m_fZ, m_fColor;
  
  protected GLTexture m_blitImage_date = null;
  protected GLTexture m_blitImage_title = null;
  
  protected PGraphics m_offscreen = null;
  protected PApplet   m_App       = null;
  
  //////////////////////////////////////////////////////
  // constructor
  //////////////////////////////////////////////////////
  
  // constructor
  CRecord(int nYear, int nMonth, int nDay, int nYearDay, int nDuration, int ndeweyclass, float fScale, String strTitle, PGraphics offscreen, PApplet app)
  {
    m_nYear = nYear;
    m_nMonth = nMonth;
    m_nDay = nDay;
    m_nYearDay = nYearDay;
    m_nDuration = nDuration;
    m_ndeweyclass = ndeweyclass;
    m_strTitle = new String(strTitle);
    m_strDate = nf(m_nMonth,2)+"/"+nf(m_nDay,2)+"/"+nf(m_nYear,4);
    m_offscreen = offscreen;
    m_App = app;
    
    m_fRadius    = float(nDuration) / 300f;
    m_fLongitude = map((nYear-2005) * 365 + nYearDay, 1-365, (2011-2005+1)*365+365, PI, 0);
    m_fLatitude  = map(nYearDay, 1, 366, TWO_PI, 0);
    m_fColor     = map(ndeweyclass, 0, 999, 0f, 1f);

    m_fX = fScale * sin(m_fLongitude) * cos(m_fLatitude);
    m_fZ = fScale * sin(m_fLongitude) * sin(m_fLatitude);
    m_fY = fScale * cos(m_fLongitude);
    
    gFont4 = createFont("Helvetica", m_fRadius*2);
    
    m_blitImage_date  = new GLTexture(m_App);
    m_blitImage_title = new GLTexture(m_App);
    this._makeImage(m_strDate, m_blitImage_date);
    this._makeImage(m_strTitle, m_blitImage_title);
  }
  
  //////////////////////////////////////////////////////
  // methods
  //////////////////////////////////////////////////////
  
  // draw
  public void draw()
  {
    pushStyle();
    pushMatrix();
    
    translate(m_fX, m_fY, m_fZ);
    colorMode(RGB, 255, 255, 255, 100);
   // fill(m_fColor, 1f, 1f, m_fColor);
   //emissive(m_fColor, 1f, 1f);
   
    if ((m_ndeweyclass < 200) && (m_ndeweyclass > 0) ) { fill(255,0,0,100); } // RED
    else if ((m_ndeweyclass < 300) && (m_ndeweyclass > 200)) { emissive(205,71,55); fill(205,71,55, 100); } // RED2
    else if ((m_ndeweyclass < 350) && (m_ndeweyclass > 300)) { emissive(211,57,138); fill(211,57,138, 100); } // PINK
    else if ((m_ndeweyclass < 400) && (m_ndeweyclass > 350)) { emissive(255,134,0); fill(255,134,0, 100); } // ORANGE
    else if ((m_ndeweyclass < 400) && (m_ndeweyclass > 350)) { emissive(255,221,0); fill(255,221,0, 100); } // YELLOW
    else if ((m_ndeweyclass < 450) && (m_ndeweyclass > 400)) { emissive(0,253,181); fill(0,253,181, 100); } // YELLOW GREEN
    else if ((m_ndeweyclass < 500) && (m_ndeweyclass > 450)) { emissive(20,167,124); fill(20,167,124, 100); } // GREEN
    else if ((m_ndeweyclass < 600) && (m_ndeweyclass > 500)) { emissive(50,131,75); fill(50,131,75, 100); } // GREEN
    else if ((m_ndeweyclass < 700) && (m_ndeweyclass > 600)) { emissive(0,189,255); fill(0,189,255, 100); } // SKY BLUE
    else if ((m_ndeweyclass < 800) && (m_ndeweyclass > 700)) { emissive(0,126,255); fill(0,126,255, 100); } // BLUE
    else if ((m_ndeweyclass < 900) && (m_ndeweyclass > 800)) { emissive(144,0,255); fill(144,0,255, 100); } // VIOLET
    else if ((m_ndeweyclass < 1000) && (m_ndeweyclass > 900)) { emissive(143,17,140); fill(143,17,140, 100); } // PINK2
    else fill(255,255,255);
    
//    box(m_fRadius, m_fRadius*8, m_fRadius*8);
    sphereDetail(6);
    sphere(m_fRadius*0.7);
    
    popMatrix();
    popStyle();
  }
  
  // draw Numbers text
  public void drawDate()
  {
    pushStyle();
    pushMatrix();

    translate(m_fX, m_fY, m_fZ);
    
    textFont(gFont4);
    
    if ((m_ndeweyclass < 200) && (m_ndeweyclass > 0) ) { stroke(255,0,0,100); } // RED
    else if ((m_ndeweyclass < 300) && (m_ndeweyclass > 200)) { emissive(205,71,55); stroke(205,71,55, 100); } // RED2
    else if ((m_ndeweyclass < 350) && (m_ndeweyclass > 300)) { emissive(211,57,138); stroke(211,57,138, 100); } // PINK
    else if ((m_ndeweyclass < 400) && (m_ndeweyclass > 350)) { emissive(255,134,0); stroke(255,134,0, 100); } // ORANGE
    else if ((m_ndeweyclass < 400) && (m_ndeweyclass > 350)) { emissive(255,221,0); stroke(255,221,0, 100); } // YELLOW
    else if ((m_ndeweyclass < 450) && (m_ndeweyclass > 400)) { emissive(0,253,181); stroke(0,253,181, 100); } // YELLOW GREEN
    else if ((m_ndeweyclass < 500) && (m_ndeweyclass > 450)) { emissive(20,167,124); stroke(20,167,124, 100); } // GREEN
    else if ((m_ndeweyclass < 600) && (m_ndeweyclass > 500)) { emissive(50,131,75); stroke(50,131,75, 100); } // GREEN
    else if ((m_ndeweyclass < 700) && (m_ndeweyclass > 600)) { emissive(0,189,255); stroke(0,189,255, 100); } // SKY BLUE
    else if ((m_ndeweyclass < 800) && (m_ndeweyclass > 700)) { emissive(0,126,255); stroke(0,126,255, 50); } // BLUE
    else if ((m_ndeweyclass < 900) && (m_ndeweyclass > 800)) { emissive(144,0,255); stroke(144,0,255, 50); } // VIOLET
    else if ((m_ndeweyclass < 1000) && (m_ndeweyclass > 900)) { emissive(143,17,140); stroke(143,17,140, 50); } // PINK2
    else fill(255,255,255);
    
    //text(nf(m_nMonth,2)+"/"+nf(m_nDay,2)+"/"+nf(m_nYear,4),0,0,0);// old way
//    rotateY(-m_fLatitude);
//    rotateZ(PI/2f-m_fLongitude);
    image(m_blitImage_date,0,0);  // draw text
    
    popMatrix();
    popStyle();
  }

  // draw Book title text
  public void drawTitle()
  {
    pushStyle();
    pushMatrix();
    
    translate(m_fX, m_fY, m_fZ);
    rotateY(-m_fLatitude);
    rotateZ(PI/2f-m_fLongitude);
    
    if ((m_ndeweyclass < 200) && (m_ndeweyclass > 0) ) { fill(255,0,0,100); } // RED
    else if ((m_ndeweyclass < 300) && (m_ndeweyclass > 200)) { fill(205,71,55, 100); } // RED2
    else if ((m_ndeweyclass < 350) && (m_ndeweyclass > 300)) { fill(211,57,138, 100); } // PINK
    else if ((m_ndeweyclass < 400) && (m_ndeweyclass > 350)) { fill(255,134,0, 100); } // ORANGE
    else if ((m_ndeweyclass < 400) && (m_ndeweyclass > 350)) { fill(255,221,0, 100); } // YELLOW
    else if ((m_ndeweyclass < 450) && (m_ndeweyclass > 400)) { fill(0,253,181, 100); } // YELLOW GREEN
    else if ((m_ndeweyclass < 500) && (m_ndeweyclass > 450)) { fill(20,167,124, 100); } // GREEN
    else if ((m_ndeweyclass < 600) && (m_ndeweyclass > 500)) { fill(50,131,75, 100); } // GREEN
    else if ((m_ndeweyclass < 700) && (m_ndeweyclass > 600)) { fill(0,189,255, 100); } // SKY BLUE
    else if ((m_ndeweyclass < 800) && (m_ndeweyclass > 700)) { fill(0,126,255, 50); } // BLUE
    else if ((m_ndeweyclass < 900) && (m_ndeweyclass > 800)) { fill(144,0,255, 50); } // VIOLET
    else if ((m_ndeweyclass < 1000) && (m_ndeweyclass > 900)) { fill(143,17,140, 50); } // PINK2
    else fill(255,255,255);
    
    //text(round(frameRate)); // ???????
    //text(m_strTitle,0,0,0);//nf(m_nMonth,2)+"/"+nf(m_nDay,2)+"/"+nf(m_nYear,4),0,0,0); // old way
    image(m_blitImage_title,0,0);  // draw text
    
    popMatrix();
    popStyle();
  }
  
  // for rendering text
  protected void _makeImage(String strText, GLTexture imagevar) {
    
    pushStyle();
    
    //Here, we draw the text to the gOffScreen graphics object.
    gOffScreen.beginDraw();
    gOffScreen.background(0);
    gOffScreen.textFont(gFont1);
    gOffScreen.textSize(14);
    gOffScreen.fill(0, 0, 0, 0);
    gOffScreen.noStroke();
    
    gOffScreen.fill(255, 255, 255, 255);
    gOffScreen.text(strText, 4, 14);
    gOffScreen.endDraw();
    
    //When we're done drawing, we grab pixels from the gOffScreen GO and store it temporarily in a PImage.
    PImage temp = gOffScreen.get(0,0,round(gOffScreen.textWidth(strText)) + 8,18);
    //Finally, we create a GLtexture, and put the image data inside of it
    //      imagevar = new GLTexture(m_App);
    imagevar.putImage(temp);
    
    popStyle();
  };
  
  //////////////////////////////////////////////////////
}
