public class CTransaction
{
  // properties
  String m_strBookname = null;
  
  protected CRecord m_Record_s = null;
  protected CRecord m_Record_e = null;
  protected CCurve m_Curve = null;
  protected int m_nDeweyClass = 0;
  protected float m_fScale = 240f;
  
  ////////////////////////////////////////////////////////////////////////////////////////
  // constructor
  ////////////////////////////////////////////////////////////////////////////////////////
  CTransaction()
  {
    ;
  }
  
  void init(String strTitle, int nYear_s, int nMonth_s, int nDay_s, int nYearDay_s, int nYear_e, int nMonth_e, int nDay_e, int nYearDay_e, int nDeweyClass, float fScale, PGraphics offscreen, PApplet app)
  {
    assert(fScale>0f);
    
    m_fScale = fScale;
    
    int nDuration = (nYear_e - nYear_s) * 365 + (nYearDay_e - nYearDay_s);
    m_nDeweyClass = nDeweyClass;
    
    // instantiate objects
    m_Record_s = new CRecord(nYear_s, nMonth_s, nDay_s, nYearDay_s, nDuration, m_nDeweyClass, m_fScale, strTitle, offscreen, app);
    m_Record_e = new CRecord(nYear_e, nMonth_e, nDay_e, nYearDay_e, nDuration, m_nDeweyClass, m_fScale, strTitle, offscreen, app);
    m_Curve = new CCurve(nYear_s, nMonth_s, nDay_s, nYearDay_s, nYear_e, nMonth_e, nDay_e, nYearDay_e, m_nDeweyClass, m_fScale);
  }
  
  ////////////////////////////////////////////////////////////////////////////////////////
  // clone
  ////////////////////////////////////////////////////////////////////////////////////////
  CTransaction clone()
  {
    return null;
  }
  
  ////////////////////////////////////////////////////////////////////////////////////////
  // 
  ////////////////////////////////////////////////////////////////////////////////////////
  // draw
  void draw(int nMode)
  {
    switch(nMode)
    {
      case 1:
      this.draw1();
      break;
      
      case 2:
      this.draw2();
      break;
      
      case 3:
      this.draw3();
      break;
      
      case 4:
      this.draw4();
      break;
      
      case 5:
      this.draw5();
      break;
      
      default:
      break;
    }
  }
  
  // mode1: draw a line between start/end of the record
  void draw1()
  {
    pushStyle();
    {
      m_Record_s.draw();
      m_Record_e.draw();
      m_Curve.draw();
    }
    popStyle();
  }
  
  void draw2()
  {
    pushStyle();
    {
       m_Curve.draw();
    }
    popStyle();
  }
  
   void draw3()
  {
    pushStyle();
    {
      m_Record_s.draw();
      m_Record_e.draw();
    }
    popStyle();
  }
  
  void draw4()
  {
    pushStyle();
    {
      m_Record_s.draw();
      m_Record_s.drawDate();
      m_Record_e.draw();
      m_Record_e.drawDate();
    }
    popStyle();
  }
 
 void draw5()
  {
      m_Record_s.drawTitle();
      m_Record_e.drawTitle();
  }
}

