void setup() {

  size(1024, 768, OPENGL);
  frameRate(30);
  smooth();

  // PeasyCam
  cam = new PeasyCam(this, 1000);
  
  //GL Graphic
  gOffScreen = createGraphics(500,200,P2D);

  //font 
  gFont1 = createFont("Helvetica", 12);
  gFont2 = createFont("Helvetica", 22);
  gFont3 = createFont("Helvetica", 11);
  textFont(gFont1);
  
  // loading data
  String savedData1[] = loadStrings(Earth_transactions1);
  String savedData2[] = loadStrings(Earth_transactions2);
  assert(savedData1.length == savedData2.length);
  gnDataLength = savedData1.length;
  
  String [] Data_BookTitle  = new String[gnDataLength];
  int []    Data_Year_s     = new int[gnDataLength];
  int []    Data_Month_s    = new int[gnDataLength];
  int []    Data_Day_s      = new int[gnDataLength];
  int []    Data_YearDay_s  = new int[gnDataLength];
  int []    Data_Year_e     = new int[gnDataLength];
  int []    Data_Month_e    = new int[gnDataLength];
  int []    Data_Day_e      = new int[gnDataLength];
  int []    Data_YearDay_e  = new int[gnDataLength];
  int []    Data_Deweyclass = new int[gnDataLength];
  
  gTransactions = new CTransaction[gnDataLength];

  for (int i=0; i < gnDataLength; i++) {
    
    String[] temp1 = split(savedData1[i], ",");
    String[] temp2 = split(savedData2[i], ",");
    String[] temp1_s_chunks = split(temp1[1], " ");
    String[] temp1_e_chunks = split(temp1[2], " ");
    String[] temp1_s_chunks_elements = split(temp1_s_chunks[0], "-");
    String[] temp1_e_chunks_elements = split(temp1_e_chunks[0], "-");
    
    int nTmpMonth_s = (int)Integer.parseInt(temp1_s_chunks_elements[1]);
    int nTmpMonth_e = (int)Integer.parseInt(temp1_e_chunks_elements[1]);
    int nTmpDay_s = (int)Integer.parseInt(temp1_s_chunks_elements[2]);
    int nTmpDay_e = (int)Integer.parseInt(temp1_e_chunks_elements[2]);
    int nYearDay_s = 0;
    int nYearDay_e = 0;
    for( int j=0; j<nTmpMonth_s-1; j++ )  {  nYearDay_s += gMonthDays[j];  } nYearDay_s += nTmpDay_s;
    for( int j=0; j<nTmpMonth_e-1; j++ )  {  nYearDay_e += gMonthDays[j];  } nYearDay_e += nTmpDay_e;
    
    Data_BookTitle[i]  = new String(temp1[0]);
    Data_Year_s[i]     = (int)Integer.parseInt(temp1_s_chunks_elements[0]);
    Data_Month_s[i]    = nTmpMonth_s;
    Data_Day_s[i]      = nTmpDay_s;
    Data_YearDay_s[i]  = nYearDay_s;
    Data_Year_e[i]     = (int)Integer.parseInt(temp1_e_chunks_elements[0]);
    Data_Month_e[i]    = nTmpMonth_e;
    Data_Day_e[i]      = nTmpDay_e;
    Data_YearDay_e[i]  = nYearDay_e;
    Data_Deweyclass[i] = (int)Integer.parseInt(temp2[0]);

    gTransactions[i] = new CTransaction();
    gTransactions[i].init(Data_BookTitle[i], Data_Year_s[i], Data_Month_s[i], Data_Day_s[i], Data_YearDay_s[i], Data_Year_e[i], Data_Month_e[i], Data_Day_e[i], Data_YearDay_e[i], Data_Deweyclass[i], gfScale, gOffScreen, this);
  }
  
}

